package com.cwhelp.modules.business.service;

import com.cwhelp.common.enums.StatusEnum;
import com.cwhelp.modules.business.domain.BssPlatform;
import org.springframework.data.domain.Example;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Sort;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * @author yan.y
 * @date 2019/07/28
 */
public interface BssPlatformService {

    /**
     * 获取分页列表数据
     * @param example 查询实例
     * @return 返回分页数据
     */
    Page<BssPlatform> getPageList(Example<BssPlatform> example);

    /**
     * 根据ID查询数据
     * @param id 主键ID
     */
    BssPlatform getById(Long id);

    /**
     * 保存数据
     * @param bssPlatform 实体对象
     */
    BssPlatform save(BssPlatform bssPlatform);

    /**
     * 状态(启用，冻结，删除)/批量状态处理
     */
    @Transactional
    Boolean updateStatus(StatusEnum statusEnum, List<Long> idList);

    /**
     * 获取平台列表数据
     * @param example 查询实例
     * @param sort 排序对象
     */
    List<BssPlatform> getListByExample(Example<BssPlatform> example, Sort sort);

    boolean repeatByContactTel(BssPlatform bssPlatform);
    boolean repeatByContactCard(BssPlatform bssPlatform);
    boolean repeatByEmail(BssPlatform bssPlatform);

}